var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { RenamingTransform, RenameTargets } from '@yellicode/elements';
import { isReservedKeyword } from './utils';
/**
 * Prefixes reserved Java keywords with a "@". This applies to:
 * - Class names
 * - Interface names
 * - Enumeration names
 * - Attribute names
 * - Operation names
 * - Operation parameter names
 */
var JavaReservedKeywordTransform = /** @class */ (function (_super) {
    __extends(JavaReservedKeywordTransform, _super);
    function JavaReservedKeywordTransform(targets) {
        if (targets === void 0) { targets = RenameTargets.all; }
        return _super.call(this, targets) || this;
    }
    JavaReservedKeywordTransform.prototype.rename = function (name, target) {
        if (!isReservedKeyword(name))
            return name;
        return "@" + name;
    };
    return JavaReservedKeywordTransform;
}(RenamingTransform));
export { JavaReservedKeywordTransform };
